package com.madeu.controller.web.webstockstatus;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.servlet.ModelAndView;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.web.webloghistory.WebLogHistoryService;
import com.madeu.service.web.webstockstatus.WebStockStatusService;
import com.madeu.util.HttpUtil;
import com.madeu.view.web.WebStockStatusView;

import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;


@Slf4j
@Controller
public class WebStockStatusController extends ManagerDraftAction{

	@Autowired
	private WebStockStatusService webStockStatusService;
	
	@Autowired
	private WebLogHistoryService webLogHistoryService;
	
	/**
	 * 입출고 현황 정보 리스트 화면으로 이동.
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockstatus/selectListStockStautsIntro.do")
	public String  selectListStockStautsIntro(HttpSession session,HttpServletRequest request, HttpServletResponse response, Model model) {
		log.debug("WebStockStatusController  selectListStockStautsIntro START");

		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return "/web/login/logout";
			}
			else {
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockStatusService.selectListStockStatusIntro(paramMap);
				
				model.addAttribute("selectUseYn", map.get("selectUseYn"));
				model.addAttribute("insertUseYn", map.get("insertUseYn"));
				model.addAttribute("updateUseYn", map.get("updateUseYn"));
				model.addAttribute("deleteUseYn", map.get("deleteUseYn"));
				model.addAttribute("downloadUseYn", map.get("downloadUseYn"));
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return "/web/login/logout";
		}
		log.debug("WebStockStatusController  selectListStockStautsIntro END");
		return "/web/stockstatus/stockStatusSelectList";
	}
	

	
	/**
	 * 현재까지 전체 입고 수량/금액, 출고 수량/금액 확인 (입출고 현황 상단)
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockstatus/selectTotalStockStatus.do")
	public ModelAndView selectTotalStockStatus(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockStatusController selectTotalStockStatus START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockStatusService.selectTotalStockStatus(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockStatusController selectTotalStockStatus END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * 입출고 현황 정보 리스트 조회
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockstatus/selectListStockStatus.do")
	public ModelAndView selectListStockStatus(HttpSession session,HttpServletRequest request, HttpServletResponse response) {
		log.debug("WebStockStatusController selectListStockStatus START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		HashMap<String, Object> map = new HashMap<String, Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				map = webStockStatusService.selectListStockStatus(paramMap);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
			return null;
		}
		finally {
			if(Constants.OK == map.get("msgCode")) {

			}
			else{
				map.put("msgCode", Constants.FAIL);
				map.put("success", false);
				if(null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
					map.put("msgDesc","정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
				}
			}
		}
		log.debug("WebStockStatusController selectListStockStatus END");
		return HttpUtil.makeHashToJsonModelAndView(map);
	}
	
	/**
	 * <b> 입출고 현황 정보 리스트 조회 엑셀 다운로드 </b>
	 * 페이지 처리 없음 
	 * request: 
	 * response : msgCode, msgDesc
	 * 
	 * @param request
	 * @param response 
	 * @return
	 */
	@RequestMapping(value="/webstockstatus/downloadStockStatusExcel.do")
	public ModelAndView downloadStockStatusExcel(HttpSession session, HttpServletRequest request, HttpServletResponse response, @RequestParam(value = "file", required = false) MultipartFile file, Model model) {
		log.debug("WebStockStatusController downloadStockStatusExcel START");
		
		HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
		Map<String, Object> selectListReport = new HashMap<String,Object>();
		Map<String, Object> map = new HashMap<String,Object>();
		
		try{
			if(!webCheckLogin(session)){
				return null;
			}
			else{
				paramMap.put("loginMemberId", String.valueOf(session.getAttribute("loginMemberId")));
				selectListReport = webStockStatusService.selectListStockStatusExcel(paramMap);
				map.put("selectListStockStatus", selectListReport);
				map.put("name", "stockstatus");
			}
		}
		catch(Exception e){
			e.printStackTrace();
			return null;
		}
		log.debug("WebStockStatusController downloadStockStatusExcel END");
		return new ModelAndView(new WebStockStatusView(),"map",map);
	}
}
